//########## IFV Puma

//### Sound

datablock AudioProfile(gc_PumaFireSound)
{
  filename = "./pumafire.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock AudioProfile(gc_PumaAAFireSound)
{
  filename = "./pumaaafire.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock AudioProfile(gc_OverheatSound)
{
  filename = "./overheat.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_ExplosionSound)
{
  filename = "./explosion.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock AudioProfile(gc_AAExplosionSound)
{
  filename = "./aaexplosion.wav";
  description = AudioClose3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_tireParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 0.3";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 2;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_tireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_tireParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_vehicleDamageParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_OverheatParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = -1.5;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 600;
  lifetimeVarianceMS = 200;
  textureName = "base/data/particles/cloud";
  spinSpeed = 1;
  spinRandomMin = -5;
  spinRandomMax = 5;
  colors[0] = "1 1 1 0.8";
  colors[1] = "1 1 1 0";
  sizes[0] = 0.2;
  sizes[1] = 0.8;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_OverheatEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 0;
  ejectionVelocity = 1;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_OverheatParticle";
  useEmitterColors = true;
};

datablock ShapeBaseImageData(gc_OverheatMount1Image)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "Fire";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 2;
  stateEmitter[0] = gc_OverheatEmitter;
  stateEmitterTime[0] = 2;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};
function gc_OverheatMount1Image::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ShapeBaseImageData(gc_OverheatMount2Image)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 2;

  stateName[0] = "Fire";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 2;
  stateEmitter[0] = gc_OverheatEmitter;
  stateEmitterTime[0] = 2;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};
function gc_OverheatMount2Image::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_PumaFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 0.5 0 1";
  colors[1] = "1 0.8 0.6 1";
  colors[2] = "1 0.3 0.1 0";
  sizes[0] = 0.1;
  sizes[1] = 2;
  sizes[2] = 0;
  times[9] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_PumaFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 250;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_PumaFlashParticle";
};

datablock ParticleData(gc_PumaSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.2;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 600;
  lifetimeVarianceMS = 200;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.3 0.3 0.3 1";
  colors[1] = "0 0 0 0.3";
  colors[2] = "0 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 2;
  sizes[2] = 5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_PumaSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 30;
  velocityVariance = 20;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 20;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_PumaSmokeParticle";
};

datablock ShapeBaseImageData(gc_PumaFireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireB";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = gc_PumaFlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "FireB";
  stateTransitionOnTimeout[1] = "Done";
  stateWaitForTimeout[1] = true;
  stateTimeoutValue[1] = 0.1;
  stateEmitter[1] = gc_PumaSmokeEmitter; 
  stateEmitterTime[1] = 0.1;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function gc_PumaFireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ShapeBaseImageData(gc_PumaAAFireLeftImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireB";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = gc_PumaFlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "FireB";
  stateTransitionOnTimeout[1] = "Done";
  stateWaitForTimeout[1] = true;
  stateTimeoutValue[1] = 0.05;
  stateEmitter[1] = gc_PumaSmokeEmitter; 
  stateEmitterTime[1] = 0.05;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function gc_PumaAAFireLeftImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ShapeBaseImageData(gc_PumaAAFireRightImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 2;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireB";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = gc_PumaFlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "FireB";
  stateTransitionOnTimeout[1] = "Done";
  stateWaitForTimeout[1] = true;
  stateTimeoutValue[1] = 0.05;
  stateEmitter[1] = gc_PumaSmokeEmitter; 
  stateEmitterTime[1] = 0.05;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function gc_PumaAAFireRightImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_PumaShellExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/star1";
  spinSpeed = 0;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 9;
  sizes[1] = 6;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_PumaShellExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 2.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_PumaShellExplosionParticle";
};

datablock ParticleData(gc_PumaShellSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 3500;
  lifetimeVarianceMS = 1500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 6;
  sizes[1] = 6;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_PumaShellSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 1;
  ejectionOffset = 2.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_PumaShellSmokeParticle";
};

datablock ExplosionData(gc_PumaShellExplosion)
{
  lifeTimeMS = 100;
  emitter[0] = gc_PumaShellExplosionEmitter;
  emitter[1] = gc_PumaShellSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  lightStartRadius = 6;
  lightEndRadius = 0;
  lightStartColor = "1 0.6 0.2";
  lightEndColor = "0 0 0";
  damageRadius = 5;
  radiusDamage = 75;
  impulseRadius = 5;
  impulseForce = 75;
  soundProfile = gc_ExplosionSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 12;
};

datablock ParticleData(gc_AAExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/star1";
  spinSpeed = 0;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 8;
  sizes[1] = 6;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_AAExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 20;
  velocityVariance = 10;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AAExplosionParticle";
};

datablock ParticleData(gc_AAExplosionSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 6;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_AAExplosionSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 8;
  velocityVariance = 2;
  ejectionOffset = 1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AAExplosionSmokeParticle";
};

datablock ExplosionData(gc_AAExplosion)
{
  lifeTimeMS = 50;
  emitter[0] = gc_AAExplosionEmitter;
  emitter[1] = gc_AAExplosionSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  soundProfile = gc_AAExplosionSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 3;
};

//### Projectile

AddDamageType("gc_Puma",'<bitmap:Add-Ons/Vehicle_Puma/CI_puma>%1','%2<bitmap:Add-Ons/Vehicle_Puma/CI_puma>%1',1,1);

datablock ProjectileData(gc_PumaShellProjectile)
{
  uiName = "";
  projectileShapeName = "./pumaprojectile.dts";
  directDamage = 0;
  directDamageType = $DamageType::gc_Puma;
  radiusDamageType = $DamageType::gc_Puma;
  brickExplosionRadius = 3;
  brickExplosionImpact = true;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 50;
  brickExplosionMaxVolumeFloating = 50;
  impactImpulse = 200;
  explosion = gc_PumaShellExplosion;
  muzzleVelocity = 200;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.25;
  explodeOnDeath = 1;
};

AddDamageType("gc_PumaAA",'<bitmap:Add-Ons/Vehicle_Puma/CI_pumaaa>%1','%2<bitmap:Add-Ons/Vehicle_Puma/CI_pumaaa>%1',1,1);

datablock ProjectileData(gc_PumaAAProjectile)
{
  uiName = "";
  projectileShapeName = "./pumaaaprojectile.dts";
  directDamage = 20;
  directDamageType = $DamageType::gc_PumaAA;
  radiusDamageType = $DamageType::gc_PumaAA;
  brickExplosionRadius = 0.5;
  brickExplosionImpact = true;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 10;
  brickExplosionMaxVolumeFloating = 10;
  impactImpulse = 100;
  explosion = gc_AAExplosion;
  muzzleVelocity = 200;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 1000;
  fadeDelay = 1000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
};

//### Turrets

datablock TSShapeConstructor(pumaturretDts)
{
  baseShape = "./pumaturret.dts";
  sequence0 = "./root.dsq root";
  sequence1 = "./look.dsq look";
  sequence2 = "./fire.dsq fire";
};

datablock TSShapeConstructor(pumaaaturretDts)
{
  baseShape = "./pumaaaturret.dts";
  sequence0 = "./root.dsq root";
  sequence1 = "./aa_look.dsq look";
  sequence2 = "./aa_fireleft.dsq fireleft";
  sequence3 = "./aa_fireright.dsq fireright";
  sequence4 = "./radar.dsq radar";
};

datablock PlayerData(gc_PumaTurretPlayer)
{
  renderFirstPerson = true;
  emap = false;
  className = Armor;
  shapeFile = "./pumaturret.dts";
  cameraMaxDist = 4;
  cameraTilt = 0.261;
  cameraVerticalOffset = 2.3;
  cameraDefaultFov = 90;
  cameraMinFov = 5;
  cameraMaxFov = 120;
  aiAvoidThis = true;
  minLookAngle = -1.5708;
  maxLookAngle = 0.5;
  maxFreelookAngle = 3;
  mass = 200000;
  drag = 1;
  density = 5;
  maxDamage = 400;
  maxEnergy = 10;
  repairRate = 0.33;
  rechargeRate = 0.4;
  runForce = 1000;
  runEnergyDrain = 0;
  minRunEnergy = 0;
  maxForwardSpeed = 0;
  maxBackwardSpeed = 0;
  maxSideSpeed = 0;
  maxForwardCrouchSpeed = 0;
  maxBackwardCrouchSpeed = 0;
  maxSideCrouchSpeed = 0;
  maxUnderwaterForwardSpeed = 0;
  maxUnderwaterBackwardSpeed = 0;
  maxUnderwaterSideSpeed = 0;
  jumpForce = 0;
  jumpEnergyDrain = 0;
  minJumpEnergy = 0;
  jumpDelay = 0;
  minJetEnergy = 0;
  jetEnergyDrain = 0;
  canJet = 0;
  minImpactSpeed = 250;
  speedDamageScale = 3.8;
  boundingBox = vectorScale("4.2 4.2 1.2",4);
  crouchBoundingBox = vectorScale("4.2 4.2 1.2",4);
  pickupRadius = 0.75;
  jetEmitter = "";
  jetGroundEmitter = "";
  jetGroundDistance = 4;
  splash = PlayerSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 0.1;
  splashEmitter[0] = PlayerFoamDropletsEmitter;
  splashEmitter[1] = PlayerFoamEmitter;
  splashEmitter[2] = PlayerBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  runSurfaceAngle = 85;
  jumpSurfaceAngle = 86;
  minJumpSpeed = 20;
  maxJumpSpeed = 30;
  horizMaxSpeed = 68;
  horizResistSpeed = 33;
  horizResistFactor = 0.35;
  upMaxSpeed = 80;
  upResistSpeed = 25;
  upResistFactor = 0.3;
  footstepSplashHeight = 0.35;
  JumpSound = "";
  groundImpactMinSpeed = 10;
  groundImpactShakeFreq = "4 4 4";
  groundImpactShakeAmp = "1 1 1";
  groundImpactShakeDuration = 0.8;
  groundImpactShakeFalloff = 10;
  maxItems = 10;
  maxWeapons = 5;
  maxTools = 5;
  uiName = "";
  rideable = true;
  lookUpLimit = 0.5;
  lookDownLimit = 0.5;
  canRide = false;
  showEnergyBar = false;
  paintable = true;
  brickImage = horseBrickImage;
  numMountPoints = 1;
  mountThread[0] = "sit";
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  useCustomPainEffects = true;
  PainHighImage = "";
  PainMidImage = "";
  PainLowImage = "";
  painSound = "";
  deathSound = "";
  useEyePoint = 1;
};

datablock PlayerData(gc_PumaAATurretPlayer : gc_PumaTurretPlayer)
{
  uiName = "";
  shapeFile = "./pumaaaturret.dts";
};

//### Vehicle

datablock WheeledVehicleTire(gc_PumaTire)
{
  shapeFile = "./emptyWheel.dts";
  mass = 10;
  radius = 0.6;
  staticFriction = 5;
  kineticFriction = 5;
  restitution = 0.5;
  lateralForce = 18000;
  lateralDamping = 4000;
  lateralRelaxation = 0.01;
  longitudinalForce = 14000;
  longitudinalDamping = 2000;
  longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(gc_PumaSpring)
{
  length = 0.6;
  force = 4000;
  damping = 1000;
  antiSwayForce = 6;
};

datablock WheeledVehicleData(gc_PumaVehicle)
{
  uiName = "IFV Puma";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./puma.dts";
  emap = true;
  minMountDist = 6;
  numMountPoints = 6;
  mountThread[0] = "sit";
  mountThread[1] = "sit";
  mountThread[2] = "sit";
  mountThread[3] = "sit";
  mountThread[4] = "sit";
  mountThread[5] = "sit";
  maxDamage = 400;
  destroyedLevel = 400;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  massCenter = "0 0 -0.5";
  maxSteeringAngle = 0.9;
  integration = 4;
  tireEmitter = gc_tireEmitter;
  cameraRoll = false;
  cameraMaxDist = 13;
  cameraOffset = 7.5;
  cameraLag = 0.0;
  cameraDecay = 0.75;
  cameraTilt = 0.4;
  collisionTol = 0.1;
  contactTol = 0.1;
  useEyePoint = false;
  defaultTire = gc_PumaTire;
  defaultSpring = gc_PumaSpring;
  numWheels = 6;
  mass = 400;
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 10;
  softImpactSpeed = 10;
  hardImpactSpeed = 15;
  groundImpactMinSpeed = 10;
  engineTorque = 3000;
  engineBrake = 500;
  brakeTorque = 2000;
  maxWheelSpeed = 20;
  rollForce = 900;
  yawForce = 600;
  pitchForce = 1000;
  rotationalDrag = 0.2;
  maxEnergy = 100;
  jetForce = 3000;
  minJetEnergy = 30;
  jetEnergyDrain = 2;
  splash = vehicleSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 1.4;
  splashEmitter[0] = vehicleFoamDropletsEmitter;
  splashEmitter[1] = vehicleFoamEmitter;
  splashEmitter[2] = vehicleBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  softImpactSound = slowImpactSound;
  hardImpactSound = fastImpactSound;
  justcollided = 0;
  rideable = true;
  lookUpLimit = 1;
  lookDownLimit = 0;
  paintable = true;
  damageEmitter[0] = gc_vehicleDamageEmitter;
  damageEmitterOffset[0] = "0 -3.4 1.2";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 -3.4 1.2";
  damageLevelTolerance[1] = 0.9;
  numDmgEmitterAreas = 1;
  initialExplosionProjectile = vehicleExplosionProjectile;
  initialExplosionOffset = 1;
  burnTime = 4000;
  finalExplosionProjectile = vehicleFinalExplosionProjectile;
  finalExplosionOffset = 0.5;
  minRunOverSpeed = 4;
  runOverDamageScale = 25;
  runOverPushScale = 1.2;
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  useEyePoint = 1;
};

datablock WheeledVehicleData(gc_PumaAAVehicle : gc_PumaVehicle)
{
  uiName = "IFV Puma - Anti Air";
};

//### Functions

function gc_PumaVehicle::onAdd(%this,%obj)
{
  for(%i=0;%i<%this.numWheels;%i++)
  {
    %obj.setWheelTire(%i,%this.defaultTire);
    %obj.setWheelSpring(%i,%this.defaultSpring);
  }
  %obj.setWheelSteering(0,1);
  %obj.setWheelSteering(1,1);
  %obj.setWheelSteering(4,-1);
  %obj.setWheelSteering(5,-1);
  %obj.setWheelPowered(0,true);
  %obj.setWheelPowered(1,true);
  %obj.setWheelPowered(2,true);
  %obj.setWheelPowered(3,true);
  %obj.setWheelPowered(4,true);
  %obj.setWheelPowered(5,true);
  %t = new AIPlayer() { dataBlock = gc_PumaTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,1);
  %obj.turret = %t;
}

function gc_PumaAAVehicle::onAdd(%this,%obj)
{
  for(%i=0;%i<%this.numWheels;%i++)
  {
    %obj.setWheelTire(%i,%this.defaultTire);
    %obj.setWheelSpring(%i,%this.defaultSpring);
  }
  %obj.setWheelSteering(0,1);
  %obj.setWheelSteering(1,1);
  %obj.setWheelSteering(4,-1);
  %obj.setWheelSteering(5,-1);
  %obj.setWheelPowered(0,true);
  %obj.setWheelPowered(1,true);
  %obj.setWheelPowered(2,true);
  %obj.setWheelPowered(3,true);
  %obj.setWheelPowered(4,true);
  %obj.setWheelPowered(5,true);
  %t = new AIPlayer() { dataBlock = gc_PumaAATurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,1);
  %obj.turret = %t;
  %t.barrelnum = 1;
  %t.playThread(0,radar);
  schedule(500,0,gc_Overheating,%t);
}

function gc_Overheating(%obj)
{
  if(!isObject(%obj)) return;
  schedule(500,0,gc_Overheating,%obj);
  if(%obj.temp > 0) %obj.temp -= 6;
  if(%obj.temp < 0) %obj.temp = 0;
  if(isObject(%obj.getMountNodeObject(0))) {
  %col = "<color:00ff00>";
  if(%obj.temp > 40) %col = "<color:ffff00>";
  if(%obj.temp > 60) %col = "<color:ff0000>";
  for(%i=0;%i<=(%obj.temp/5);%i++) { %a = %a @ "|"; }
  bottomPrint(%obj.getMountNodeObject(0).client,%col @ "Barrel Temp: " @ %a,2); }
}

function gc_PumaVehicle::onRemove(%this,%obj) { if(isObject(%obj.turret)) %obj.turret.delete(); }
function gc_PumaAAVehicle::onRemove(%this,%obj) { if(isObject(%obj.turret)) %obj.turret.delete(); }

package gc_PumaPackage
{
  function Player::Burn(%obj,%time)
  {
    if(%obj.dataBlock $= gc_PumaTurretPlayer) return;
    if(%obj.dataBlock $= gc_PumaAATurretPlayer) return;
    parent::Burn(%obj,%time);
  }
  function ShapeBase::setNodeColor(%obj,%node,%color)
  {
    parent::setnodecolor(%obj,%node,%color);
    if(isObject(%obj.turret)) %obj.turret.setNodeColor("ALL",%color);
  }
  function gc_PumaVehicle::Damage(%this,%obj,%source,%pos,%amount,%type)
  {
    if(%amount < 40) %amount /= 2;
    if((%obj.getDamageLevel()+%amount) >= %this.maxDamage)
    {
      if(%obj.destroyed) return;
      %obj.setNodeColor("ALL","0 0 0 1");
      if(isObject(%obj.turret)) %obj.turret.delete();
      %p = new Projectile()
      {
        dataBlock = vehicleExplosionProjectile;
        initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
        initialVelocity = "0 0 1";
        client = %obj.lastDamageClient;
        sourceClient = %obj.lastDamageClient;
      };
      MissionCleanup.add(%p);
      if(%obj.destroyed) return;
      %obj.setDamageLevel(%this.maxDamage);
      %obj.destroyed = 1;
      %obj.schedule(%this.burnTime,"finalExplosion");
      if(isObject(%obj.spawnBrick.client.minigame)) %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
      %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
    }
    else
      parent::Damage(%this,%obj,%source,%pos,%amount,%type);
  }
  function gc_PumaAAVehicle::Damage(%this,%obj,%source,%pos,%amount,%type)
  {
    if(%amount < 40) %amount /= 2;
    if((%obj.getDamageLevel()+%amount) >= %this.maxDamage)
    {
      if(%obj.destroyed) return;
      %obj.setNodeColor("ALL","0 0 0 1");
      if(isObject(%obj.turret)) %obj.turret.delete();
      %p = new Projectile()
      {
        dataBlock = vehicleExplosionProjectile;
        initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
        initialVelocity = "0 0 1";
        client = %obj.lastDamageClient;
        sourceClient = %obj.lastDamageClient;
      };
      MissionCleanup.add(%p);
      if(%obj.destroyed) return;
      %obj.setDamageLevel(%this.maxDamage);
      %obj.destroyed = 1;
      %obj.schedule(%this.burnTime,"finalExplosion");
      if(isObject(%obj.spawnBrick.client.minigame)) %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
      %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
    }
    else
      parent::Damage(%this,%obj,%source,%pos,%amount,%type);
  }
  function Player::emote(%obj,%emote)
  {
    if(%obj.dataBlock $= gc_PumaTurretPlayer) return;
    if(%obj.dataBlock $= gc_PumaAATurretPlayer) return;
    parent::emote(%obj,%emote);
  }
  function gc_PumaTurretPlayer::Damage(%this,%obj,%source,%pos,%amount,%type) { parent::Damage(%this,%obj,%source,%pos,0,%type); }
  function gc_PumaAATurretPlayer::Damage(%this,%obj,%source,%pos,%amount,%type) { parent::Damage(%this,%obj,%source,%pos,0,%type); }
  function gc_PumaTurretPlayer::onDisabled(%this,%obj,%state)
  {
    %pos = %obj.getHackPosition();
    %p = new Projectile()
    {
      dataBlock = vehicleFinalExplosionProjectile;
      initialPosition = %pos;
      initialVelocity = "0 0 1";
      client = %obj.lastDamageClient;
      sourceClient = %obj.lastDamageClient;
    };
    MissionCleanup.add(%p);
    %obj.schedule(10,"delete");
    if(isObject(%obj.spawnBrick))
    {
      %mg = getMiniGameFromObject(%obj);
      if(isObject(%mg)) %obj.spawnBrick.spawnVehicle(%mg.vehicleReSpawnTime);
      else
        %obj.spawnBrick.spawnVehicle(0);
    }
    parent::onDisabled(%this,%obj,%state);
  }
  function gc_PumaAATurretPlayer::onDisabled(%this,%obj,%state)
  {
    %pos = %obj.getHackPosition();
    %p = new Projectile()
    {
      dataBlock = vehicleFinalExplosionProjectile;
      initialPosition = %pos;
      initialVelocity = "0 0 1";
      client = %obj.lastDamageClient;
      sourceClient = %obj.lastDamageClient;
    };
    MissionCleanup.add(%p);
    %obj.schedule(10,"delete");
    if(isObject(%obj.spawnBrick))
    {
      %mg = getMiniGameFromObject(%obj);
      if(isObject(%mg)) %obj.spawnBrick.spawnVehicle(%mg.vehicleReSpawnTime);
      else
        %obj.spawnBrick.spawnVehicle(0);
    }
    parent::onDisabled(%this,%obj,%state);
  }
  function armor::onMount(%this,%obj,%col,%slot)
  {
    parent::onMount(%this,%obj,%col,%slot);
    if(isObject(%obj.client)) {
      if(%col.getDataBlock() == gc_PumaTurretPlayer.getId()) ServerCmdUnUseTool(%obj.client);
      if(%col.getDataBlock() == gc_PumaAATurretPlayer.getId()) ServerCmdUnUseTool(%obj.client); }
  }
  function armor::onTrigger(%this,%obj,%triggerNum,%val)
  {
    %mount = %obj.getObjectMount();
    if(isObject(%mount))
    {
      if(!%val) cancel(%obj.gc_PumaLoop);
      if(%mount.getDataBlock() == gc_PumaTurretPlayer.getId() && %triggerNum == 0 && %val)
        if(getSimTime() - %obj.lastShotTime > 500) { %obj.gc_PumaFire(%val); %obj.lastShotTime = getSimTime(); }
      if(!%val) cancel(%obj.gc_PumaAALoop);
      if(%mount.getDataBlock() == gc_PumaAATurretPlayer.getId() && %triggerNum == 0 && %val) %obj.gc_PumaAAFire(%val);
    }
    parent::onTrigger(%this,%obj,%triggerNum,%val);
  }
  function Player::gc_PumaFire(%obj,%val)
  {
    if(!%val) { cancel(%obj.gc_PumaLoop); return; }
    if(!isObject(%obj.getObjectMount())) { cancel(%obj.gc_PumaLoop); return; }
    if(%obj.getObjectMount().getDataBlock() != gc_PumaTurretPlayer.getId()) { cancel(%obj.gc_PumaLoop); return; }
    %client = %obj.client;
    if(isObject(%client)) ServerCmdUnUseTool(%client);
    %mount = %obj.getObjectMount();
    %scaleFactor = getWord(%mount.getScale(),2);
    %p = new Projectile()
    {
      dataBlock = gc_PumaShellProjectile;
      initialPosition = %mount.getSlotTransform(1);
      initialVelocity = vectorScale(%mount.getMuzzleVector(1),200);
      sourceObject = %obj;
      client = %client;
      sourceSlot = 0;
      originPoint = %mount.getSlotTransform(1);
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    %mount.mountImage(gc_PumaFireImage,1);
    %mount.playThread(0,fire);
    serverPlay3D(gc_PumaFireSound,%obj.getPosition());
    %obj.gc_PumaLoop = %obj.schedule(500,gc_PumaFire,%val);
    return;
  }
  function Player::gc_PumaAAFire(%obj,%val)
  {
    if(!%val) { cancel(%obj.gc_PumaAALoop); return; }
    if(!isObject(%obj.getObjectMount())) { cancel(%obj.gc_PumaAALoop); return; }
    if(%obj.getObjectMount().getDataBlock() != gc_PumaAATurretPlayer.getId()) { cancel(%obj.gc_PumaAALoop); return; }
    if(%obj.getObjectMount().temp >= 80 & %obj.getObjectMount().overheat == 0) { serverPlay3D(gc_OverheatSound,%obj.getPosition()); %obj.getObjectMount().overheat = 1; %obj.getObjectMount().mountImage(gc_OverheatMount1Image,1); %obj.getObjectMount().mountImage(gc_OverheatMount2Image,2); cancel(%obj.gc_PumaAALoop); return; }
    if(%obj.getObjectMount().overheat == 1) {
      if(%obj.getObjectMount().temp >= 60) { cancel(%obj.gc_PumaAALoop); return; }
      else
        { %obj.getObjectMount().overheat = 0; } }
    %client = %obj.client;
    if(isObject(%client)) ServerCmdUnUseTool(%client);
    %mount = %obj.getObjectMount();
    %scaleFactor = getWord(%mount.getScale(),2);
    %barrel = %mount.barrelnum;
    %p = new Projectile()
    {
      dataBlock = gc_PumaAAProjectile;
      initialPosition = %mount.getSlotTransform(%barrel);
      initialVelocity = MatrixMulVector(MatrixCreateFromEuler(((getRandom()-0.5)*0.02) SPC ((getRandom()-0.5)*0.02) SPC ((getRandom()-0.5)*0.02)),VectorScale(%mount.getMuzzleVector(2),200));
      sourceObject = %obj;
      client = %client;
      sourceSlot = 0;
      originPoint = %mount.getSlotTransform(%barrel);
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    if(%barrel == 1) { %mount.playThread(1,fireleft); %mount.mountImage(gc_PumaAAFireLeftImage,1); }
    if(%barrel == 2) { %mount.playThread(2,fireright); %mount.mountImage(gc_PumaAAFireRightImage,1); }
    serverPlay3D(gc_PumaAAFireSound,%obj.getPosition());
    %mount.temp += 2;
    %col = "<color:00ff00>";
    if(%mount.temp > 40) %col = "<color:ffff00>";
    if(%mount.temp > 60) %col = "<color:ff0000>";
    for(%i=0;%i<=(%mount.temp/5);%i++) { %a = %a @ "|"; }
    bottomPrint(%obj.client,%col @ "Barrel Temp: " @ %a,2);
    %obj.gc_PumaAALoop = %obj.schedule(75,gc_PumaAAFire,%val);
    %mount.barrelnum++;
    if(%mount.barrelnum > 2) %mount.barrelnum = 1;
    return;
  }
  function Projectile::onAdd(%obj,%a,%b)
  {
    parent::onAdd(%obj,%a,%b);
    if(%obj.dataBlock.getID() == gc_PumaAAProjectile.getID()) %obj.initialVelocity = VectorScale(vectorNormalize(%obj.initialvelocity),750);
  }
};
activatepackage(gc_PumaPackage);
